<script lang="ts">
  /* eslint-disable @typescript-eslint/restrict-template-expressions */
  import { onMount } from 'svelte';
  import Time from 'svelte-time';
  import { getNotificationsContext } from 'svelte-notifications';
  import type { EventConfiguration, EventConfigurationReturn } from '@models/EventConfigurations';
  import { AllEventCfgQuery } from '@models/EventConfigurations';
  import { Gql } from '../../db';
  import Modal from './EventConfigurationModal.svelte';
  import { EventRole } from '@auth/models';

  const { addNotification } = getNotificationsContext();

  let events: Array<EventConfiguration> = [];
  let selectEvent: EventConfiguration;

  let showPopup = false;

  const onShowModal = (event: EventConfiguration) => {
    selectEvent = event;
    showPopup = true;
  };

  const onModalCancel = () => {
    showPopup = false;
  };

  async function refreshData() {
    events = (
      (await Gql.query(AllEventCfgQuery, {
        role: EventRole.EventAdmin,
      })) as EventConfigurationReturn
    ).event_configuration;
  }

  function saveChanges(editedEvent: EventConfiguration) {
    let mutationQuery = 'mutation {';
    if (editedEvent.active) {
      mutationQuery += `disable_all_but_one: update_event_configuration(
                where: {id: {_neq: ${editedEvent.id}}},_set: {active: false}) {
                affected_rows
            }`;
    }
    mutationQuery += `
            update_one: update_event_configuration(where: {id: {_eq: ${editedEvent.id}}}, _set: {
                name: "${editedEvent.name}",
                org_link: "${editedEvent.org_link}",
                active: ${editedEvent.active},
                break_start: "${editedEvent.break_start}",
                break_end: "${editedEvent.break_end}",
                start: "${editedEvent.start}"
                end: "${editedEvent.end}"
                event_open: "${editedEvent.event_open}"
                event_close: "${editedEvent.event_close}"
            }) {
                affected_rows
            }
        }`;
    Gql.query(mutationQuery, { role: EventRole.EventAdmin })
      .then((response) => {
        type Resp = {
          disable_all_but_one: {
            affected_rows;
          };
          update_one: {
            affected_rows;
          };
        };
        const resp = response as Resp;
        if (resp.update_one.affected_rows === 1) {
          addNotification({
            text: 'Successfully updated event! ',
            position: 'top-center',
            removeAfter: 4000,
            type: 'success',
          });
        } else {
          addNotification({
            text: 'Something went wrong 😿 ',
            position: 'top-center',
            removeAfter: 4000,
            type: 'danger',
          });
        }
      })
      .catch((e: Error) => {
        addNotification({
          // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
          text: `Something went wrong 😿: ${e[0].message}`,
          position: 'top-center',
          removeAfter: 4000,
          type: 'danger',
        });
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        console.log(e[0].message);
      });
    // Update the data on the page
    // eslint-disable-next-line @typescript-eslint/no-floating-promises
    refreshData();
  }
  const onModalSaved = (editedEvent: EventConfiguration) => {
    showPopup = false;
    saveChanges(editedEvent);
  };
  onMount(async () => {
    await refreshData();
  });
</script>

<div class="container">
  <Modal open={showPopup} onClosed={() => onModalCancel()} onSaved={(data) => onModalSaved(data)} event={selectEvent} />
</div>

<div class="table-responsive">
  <table class="table table-sm">
    <thead>
      <tr>
        <th>ID</th>
        <th>Date</th>
        <th>Active</th>
        <th>Name</th>
        <th>Organization Link</th>
        <th>Break Start</th>
        <th>Break End</th>
        <th>Start / End</th>
        <th>Event Open / Close</th>
        <th>Controls</th>
      </tr>
    </thead>
    <tbody>
      {#each events as event}
        <tr>
          <td>{event.id}</td>
          <td>
            <Time timestamp={event.date} />
          </td>
          <td>{event.active}</td>
          <td>{event.name}</td>
          <td>{event.org_link}</td>
          <td>{event.break_start}</td>
          <td>{event.break_end}</td>
          <td style="text-align: center">
            <Time timestamp={event.start} format="MMM DD YYYY" />
            <br />
            <Time timestamp={event.start} format="hh:mm A Z" />
            <br /> -> <br />
            <Time timestamp={event.end} format="MMM DD YYYY" />
            <br />
            <Time timestamp={event.end} format="hh:mm A Z" />
          </td>
          <td style="text-align: center">
            <Time timestamp={event.event_open} format="MMM DD YYYY" />
            <br />
            <Time timestamp={event.event_open} format="hh:mm A Z" />
            <br /> -> <br />
            <Time timestamp={event.event_close} format="MMM DD YYYY" />
            <br />
            <Time timestamp={event.event_close} format="hh:mm A Z" />
          </td>
          <td>
            <div class="btn-group btn-group-sm">
              <button type="button" class="btn btn-warning btn-edit" on:click={() => onShowModal(event)}>
                <i class="fa fa-pencil" />
              </button>
            </div>
          </td>
        </tr>
      {/each}
    </tbody>
  </table>
</div>

<style>
  time {
    white-space: nowrap;
  }

  th {
    text-align: center;
  }
</style>
